// compile with
// gcc example.cc -lpthread -lboost_threads -o example

#include "spawn.h"
#include <iostream>
#include <vector>
#include <unistd.h>
#include <time.h>

// -----------------------------------------


using namespace std;

struct Y 
{
//     Y() { cout << __PRETTY_FUNCTION__ << endl; };
//     Y(const Y&) { cout << __PRETTY_FUNCTION__ << endl; };
//     ~Y() { cout << __PRETTY_FUNCTION__ << endl; };
//     Y& operator= (const Y&) { cout << __PRETTY_FUNCTION__ << endl; return *this;};
};

struct X 
{
    double &bar (double d) 
      {
        static double dd = 2.;
        sleep (1);
        cout << "X::bar(" << d << ") called" << endl;
        return dd;
      }

    void baz (Y d) 
      {
        cout << "X::baz(Y) called" << endl;
      }

    double operator() (int i, int j, int k)
      {
        static double dd = 2.;
        sleep (1);
        cout << "X(" << i << "," << j << "," << k << ") called" << endl;
        return dd;
      }
};


int main () {
  X x;

  if (true)
    {
      thread_group<double&> threads;
      for (unsigned int i=0; i<2; ++i)
        threads += spawn(x, &X::bar)(1.*i);
      threads.join_all ();
    }

  if (true)
    {
      thread_group<void> threads;
      for (unsigned int i=0; i<1; ++i)
        threads += spawn(x, &X::baz)(Y());
      threads.join_all ();
      cout << "joined" << std::endl;
    }

  spawn (x, &X::operator())(42,13,123).join();
  
  cout << "done" << endl;
}
